diff --git a/base/server/cms/src/com/netscape/cms/authentication/CMCUserSignedAuth.java b/base/server/cms/src/com/netscape/cms/authentication/CMCUserSignedAuth.java
index a18c25e..2e4d6dc 100644
--- a/base/server/cms/src/com/netscape/cms/authentication/CMCUserSignedAuth.java
+++ b/base/server/cms/src/com/netscape/cms/authentication/CMCUserSignedAuth.java
@@ -29,9 +29,9 @@ import java.io.ByteArrayInputStream;
 import java.io.ByteArrayOutputStream;
 import java.io.IOException;
 import java.math.BigInteger;
-import java.security.cert.CertificateExpiredException;
 import java.security.MessageDigest;
 import java.security.PublicKey;
+import java.security.cert.CertificateExpiredException;
 import java.util.Enumeration;
 import java.util.Hashtable;
 import java.util.Locale;
@@ -323,85 +323,90 @@ public class CMCUserSignedAuth implements IAuthManager, IExtendedPluginInfo,
                 byte[] cmcBlob = CMS.AtoB(asciiBASE64Blob);
                 ByteArrayInputStream cmcBlobIn = new ByteArrayInputStream(cmcBlob);
 
-                org.mozilla.jss.pkix.cms.ContentInfo cmcReq =
-                        (org.mozilla.jss.pkix.cms.ContentInfo) org.mozilla.jss.pkix.cms.ContentInfo
+                org.mozilla.jss.pkix.cms.ContentInfo cmcReq = (org.mozilla.jss.pkix.cms.ContentInfo) org.mozilla.jss.pkix.cms.ContentInfo
                         .getTemplate().decode(
                                 cmcBlobIn);
 
-                if (!cmcReq.getContentType().equals(
-                        org.mozilla.jss.pkix.cms.ContentInfo.SIGNED_DATA) ||
-                        !cmcReq.hasContent()) {
-
-                    cmcBlobIn.close();
-                    msg = "cmc rquest content type is not ContentInfo.SIGNED_DATA";
-                    CMS.debug(msg);
-                    throw new EBaseException(msg);
-                }
-
-                SignedData cmcFullReq = (SignedData) cmcReq.getInterpretedContent();
-
                 String userid = ILogger.UNIDENTIFIED;
                 String uid = ILogger.UNIDENTIFIED;
 
-                IConfigStore cmc_config = CMS.getConfigStore();
-                boolean checkSignerInfo = cmc_config.getBoolean("cmc.signerInfo.verify", true);
-                if (checkSignerInfo) {
-                    // selfSigned will be set in verifySignerInfo if applicable
-                    IAuthToken userToken = verifySignerInfo(auditContext, authToken, cmcFullReq);
-                    if (userToken == null) {
-                        msg = "userToken null; verifySignerInfo failure";
-                        CMS.debug(method + msg);
-                        throw new EBaseException(msg);
-                    } else {
-                        if (selfSigned) {
-                            CMS.debug(method
-                                    + " self-signed cmc request will not have user identification info at this point.");
-                            auditSignerInfo = "selfSigned";
+                SignedData cmcFullReq = null;
+                OCTET_STRING content = null;
+                OBJECT_IDENTIFIER id = null;
+                org.mozilla.jss.pkix.cms.SignerInfo selfsign_signerInfo = null;
+                if (cmcReq.getContentType().equals(
+                        org.mozilla.jss.pkix.cms.ContentInfo.SIGNED_DATA)) {
+                    CMS.debug(method + "cmc request content is signed data");
+                    cmcFullReq = (SignedData) cmcReq.getInterpretedContent();
+
+                    IConfigStore cmc_config = CMS.getConfigStore();
+                    boolean checkSignerInfo = cmc_config.getBoolean("cmc.signerInfo.verify", true);
+                    if (checkSignerInfo) {
+                        // selfSigned will be set in verifySignerInfo if applicable
+                        IAuthToken userToken = verifySignerInfo(auditContext, authToken, cmcFullReq);
+                        if (userToken == null) {
+                            msg = "userToken null; verifySignerInfo failure";
+                            CMS.debug(method + msg);
+                            throw new EBaseException(msg);
                         } else {
-                            CMS.debug(method + "signed with user cert");
-                            userid = userToken.getInString("userid");
-                            uid = userToken.getInString("cn");
-                            if (userid == null && uid == null) {
-                                msg = " verifySignerInfo failure... missing userid and cn";
-                                CMS.debug(method + msg);
-                                throw new EBaseException(msg);
-                            }
-                            // reset value of auditSignerInfo
-                            if (uid != null && !uid.equals(ILogger.UNIDENTIFIED)) {
-                                CMS.debug(method + "setting auditSignerInfo to uid:" + uid.trim());
-                                auditSignerInfo = uid.trim();
-                                auditSubjectID = uid.trim();
-                                authToken.set(IAuthToken.USER_ID, auditSubjectID);
-                            } else if (userid != null && !userid.equals(ILogger.UNIDENTIFIED)) {
-                                CMS.debug(method + "setting auditSignerInfo to userid:" + userid);
-                                auditSignerInfo = userid.trim();
-                                auditSubjectID = userid.trim();
-                                authToken.set(IAuthToken.USER_ID, auditSubjectID);
+                            if (selfSigned) {
+                                CMS.debug(method
+                                        + " self-signed cmc request will not have user identification info at this point.");
+                                auditSignerInfo = "selfSigned";
+                            } else {
+                                CMS.debug(method + "signed with user cert");
+                                userid = userToken.getInString("userid");
+                                uid = userToken.getInString("cn");
+                                if (userid == null && uid == null) {
+                                    msg = " verifySignerInfo failure... missing userid and cn";
+                                    CMS.debug(method + msg);
+                                    throw new EBaseException(msg);
+                                }
+                                // reset value of auditSignerInfo
+                                if (uid != null && !uid.equals(ILogger.UNIDENTIFIED)) {
+                                    CMS.debug(method + "setting auditSignerInfo to uid:" + uid.trim());
+                                    auditSignerInfo = uid.trim();
+                                    auditSubjectID = uid.trim();
+                                    authToken.set(IAuthToken.USER_ID, auditSubjectID);
+                                } else if (userid != null && !userid.equals(ILogger.UNIDENTIFIED)) {
+                                    CMS.debug(method + "setting auditSignerInfo to userid:" + userid);
+                                    auditSignerInfo = userid.trim();
+                                    auditSubjectID = userid.trim();
+                                    authToken.set(IAuthToken.USER_ID, auditSubjectID);
+                                }
                             }
                         }
+                    } else {
+                        CMS.debug(method + " signerInfo verification bypassed");
                     }
-                } else {
-                    CMS.debug(method + " signerInfo verification bypassed");
-                }
 
-                EncapsulatedContentInfo ci = cmcFullReq.getContentInfo();
-                SET sis = cmcFullReq.getSignerInfos();
-                // only one SignerInfo for selfSigned
-                org.mozilla.jss.pkix.cms.SignerInfo selfsign_signerInfo =
-                        (org.mozilla.jss.pkix.cms.SignerInfo) sis.elementAt(0);
+                    EncapsulatedContentInfo ci = cmcFullReq.getContentInfo();
+                    SET sis = cmcFullReq.getSignerInfos();
+                    // only one SignerInfo for selfSigned
+                    selfsign_signerInfo = (org.mozilla.jss.pkix.cms.SignerInfo) sis.elementAt(0);
 
-                OBJECT_IDENTIFIER id = ci.getContentType();
+                    id = ci.getContentType();
 
-                if (!id.equals(OBJECT_IDENTIFIER.id_cct_PKIData) ||
-                        !ci.hasContent()) {
-                    msg = "request EncapsulatedContentInfo content type not OBJECT_IDENTIFIER.id_cct_PKIData";
-                    CMS.debug(method + msg);
+                    if (!id.equals(OBJECT_IDENTIFIER.id_cct_PKIData) ||
+                            !ci.hasContent()) {
+                        msg = "request EncapsulatedContentInfo content type not OBJECT_IDENTIFIER.id_cct_PKIData";
+                        CMS.debug(method + msg);
+
+                        throw new EBaseException(msg);
+                    }
 
+                    content = ci.getContent();
+                } else if (cmcReq.getContentType().equals( //unsigned
+                        org.mozilla.jss.pkix.cms.ContentInfo.DATA)) {
+                    CMS.debug(method + "cmc request content is unsigned data...verifySignerInfo will not be called;");
+                    content = (OCTET_STRING) cmcReq.getInterpretedContent();
+                } else {
+                    cmcBlobIn.close();
+                    msg = "unsupported cmc rquest content type; must be either ContentInfo.SIGNED_DATA or ContentInfo.DATA;";
+                    CMS.debug(msg);
                     throw new EBaseException(msg);
                 }
 
-                OCTET_STRING content = ci.getContent();
-
                 ByteArrayInputStream s = new ByteArrayInputStream(content.toByteArray());
                 PKIData pkiData = (PKIData) (new PKIData.Template()).decode(s);
 
@@ -426,7 +431,8 @@ public class CMCUserSignedAuth implements IAuthManager, IExtendedPluginInfo,
 
                             if (type.equals(
                                     OBJECT_IDENTIFIER.id_cmc_revokeRequest)) {
-                                /* TODO: user-signed revocation to be handled in next ticket
+                                //further checks and actual revocation happen in CMCOutputTemplate
+
                                 // if( i ==1 ) {
                                 //     taggedAttribute.getType() ==
                                 //       OBJECT_IDENTIFIER.id_cmc_revokeRequest
@@ -440,25 +446,23 @@ public class CMCUserSignedAuth implements IAuthManager, IExtendedPluginInfo,
                                 for (int j = 0; j < numVals; j++) {
                                     // serialNumber    INTEGER
 
-                                    // SEQUENCE RevRequest = (SEQUENCE)
+                                    // SEQUENCE RevokeRequest = (SEQUENCE)
                                     //     values.elementAt(j);
                                     byte[] encoded = ASN1Util.encode(
                                             values.elementAt(j));
-                                    org.mozilla.jss.asn1.ASN1Template template = new
-                                            org.mozilla.jss.pkix.cmmf.RevRequest.Template();
-                                    org.mozilla.jss.pkix.cmmf.RevRequest revRequest =
-                                            (org.mozilla.jss.pkix.cmmf.RevRequest)
-                                            ASN1Util.decode(template, encoded);
+                                    org.mozilla.jss.asn1.ASN1Template template = new org.mozilla.jss.pkix.cmc.RevokeRequest.Template();
+                                    org.mozilla.jss.pkix.cmc.RevokeRequest revRequest = (org.mozilla.jss.pkix.cmc.RevokeRequest) ASN1Util
+                                            .decode(template, encoded);
 
-                                    // SEQUENCE RevRequest = (SEQUENCE)
+                                    // SEQUENCE RevokeRequest = (SEQUENCE)
                                     //     ASN1Util.decode(
                                     //         SEQUENCE.getTemplate(),
                                     //         ASN1Util.encode(
                                     //         values.elementAt(j)));
 
-                                    // SEQUENCE RevRequest =
+                                    // SEQUENCE RevokeRequest =
                                     //     values.elementAt(j);
-                                    // int revReqSize = RevRequest.size();
+                                    // int revReqSize = RevokeRequest.size();
                                     // if( revReqSize > 3 ) {
                                     //     INTEGER serialNumber =
                                     //         new INTEGER((long)0);
@@ -473,13 +477,10 @@ public class CMCUserSignedAuth implements IAuthManager, IExtendedPluginInfo,
                                     Integer IntObject = Integer.valueOf((int) reasonCode);
                                     authToken.set(REASON_CODE, IntObject);
 
-
                                     //authToken.set("uid", uid);
                                     //authToken.set("userid", userid);
 
                                 }
-                                */
-
                             }
                         }
 
@@ -648,8 +649,7 @@ public class CMCUserSignedAuth implements IAuthManager, IExtendedPluginInfo,
                                 certInfoArray[i] = certInfo;
 
                                 if (selfSigned) {
-                                    selfsign_skiExtn =
-                                            (SubjectKeyIdentifierExtension) CryptoUtil
+                                    selfsign_skiExtn = (SubjectKeyIdentifierExtension) CryptoUtil
                                             .getExtensionFromCertTemplate(template, PKIXExtensions.SubjectKey_Id);
                                     if (selfsign_skiExtn != null) {
                                         CMS.debug(method +
@@ -702,16 +702,24 @@ public class CMCUserSignedAuth implements IAuthManager, IExtendedPluginInfo,
                 throw new EInvalidCredentials(e.toString());
             }
 
-            // store a message in the signed audit log file
-            auditMessage = CMS.getLogMessage(
-                    AuditEvent.CMC_USER_SIGNED_REQUEST_SIG_VERIFY_SUCCESS,
-                    auditSubjectID,
-                    ILogger.SUCCESS,
-                    auditReqType,
-                    auditCertSubject,
-                    auditSignerInfo);
-
-            audit(auditMessage);
+            // For accuracy, make sure revocation by shared secret doesn't
+            // log CMC_USER_SIGNED_REQUEST_SIG_VERIFY_SUCCESS
+            if (authToken.get(IAuthManager.CRED_CMC_SIGNING_CERT) != null ||
+                    authToken.get(IAuthManager.CRED_CMC_SELF_SIGNED) != null) {
+                // store a message in the signed audit log file
+                auditMessage = CMS.getLogMessage(
+                        AuditEvent.CMC_USER_SIGNED_REQUEST_SIG_VERIFY_SUCCESS,
+                        auditSubjectID,
+                        ILogger.SUCCESS,
+                        auditReqType,
+                        auditCertSubject,
+                        auditSignerInfo);
+
+                audit(auditMessage);
+            } else {
+                CMS.debug(method
+                        + "audit event CMC_USER_SIGNED_REQUEST_SIG_VERIFY_SUCCESS not logged due to unsigned data for revocation with shared secret.");
+            }
 
             CMS.debug(method + "ends successfully; returning authToken");
             return authToken;
@@ -1029,10 +1037,15 @@ public class CMCUserSignedAuth implements IAuthManager, IExtendedPluginInfo,
                         } else {
                             CMS.debug(method + "found signing cert... verifying");
 
-                            //capture auditSubjectID first in case of failure
-                            netscape.security.x509.X500Name tempPrincipal =
+                            // capture auditSubjectID first in case of failure
+                            netscape.security.x509.X500Name principal =
                                     (X500Name) x509Certs[0].getSubjectDN();
-                            CN = tempPrincipal.getCommonName(); //tempToken.get("userid");
+
+                            // capture signer principal to be checked against
+                            // cert subject principal later in CMCOutputTemplate
+                            // in case of user signed revocation
+                            auditContext.put(SessionContext.CMC_SIGNER_PRINCIPAL, principal);
+                            CN = principal.getCommonName(); //tempToken.get("userid");
                             CMS.debug(method + " Principal name = " + CN);
                             auditContext.put(SessionContext.USER_ID, CN);
 
@@ -1093,15 +1106,18 @@ public class CMCUserSignedAuth implements IAuthManager, IExtendedPluginInfo,
                         // now check revocation status of the cert
                         if (CMS.isRevoked(x509Certs)) {
                             CMS.debug(method + "CMC signing cert is a revoked certificate");
+                            s.close();
                             throw new EInvalidCredentials(CMS.getUserMessage("CMS_AUTHENTICATION_INVALID_CREDENTIAL"));
                         }
                         try { //do this again anyways
                             cert.checkValidity();
                         } catch (CertificateExpiredException e) {
                             CMS.debug(method + "CMC signing cert is an expired certificate");
+                            s.close();
                             throw new EInvalidCredentials(CMS.getUserMessage("CMS_AUTHENTICATION_INVALID_CREDENTIAL"));
                         } catch (Exception e) {
                             CMS.debug(method + e.toString());
+                            s.close();
                             throw new EInvalidCredentials(CMS.getUserMessage("CMS_AUTHENTICATION_INVALID_CREDENTIAL"));
                         }
 
diff --git a/base/server/cms/src/com/netscape/cms/profile/common/EnrollProfile.java b/base/server/cms/src/com/netscape/cms/profile/common/EnrollProfile.java
index 12fb736..bc5de32 100644
--- a/base/server/cms/src/com/netscape/cms/profile/common/EnrollProfile.java
+++ b/base/server/cms/src/com/netscape/cms/profile/common/EnrollProfile.java
@@ -587,16 +587,25 @@ public abstract class EnrollProfile extends BasicProfile
         try {
             byte data[] = CMS.AtoB(creq);
             ByteArrayInputStream cmcBlobIn = new ByteArrayInputStream(data);
+            PKIData pkiData = null;
 
             org.mozilla.jss.pkix.cms.ContentInfo cmcReq = (org.mozilla.jss.pkix.cms.ContentInfo) org.mozilla.jss.pkix.cms.ContentInfo
                     .getTemplate().decode(cmcBlobIn);
-            org.mozilla.jss.pkix.cms.SignedData cmcFullReq = (org.mozilla.jss.pkix.cms.SignedData) cmcReq
-                    .getInterpretedContent();
-            org.mozilla.jss.pkix.cms.EncapsulatedContentInfo ci = cmcFullReq.getContentInfo();
-            OCTET_STRING content = ci.getContent();
-
+            OCTET_STRING content = null;
+            if (cmcReq.getContentType().equals(
+                    org.mozilla.jss.pkix.cms.ContentInfo.SIGNED_DATA)) {
+                CMS.debug(method + "cmc request content is signed data");
+                org.mozilla.jss.pkix.cms.SignedData cmcFullReq = (org.mozilla.jss.pkix.cms.SignedData) cmcReq
+                        .getInterpretedContent();
+                org.mozilla.jss.pkix.cms.EncapsulatedContentInfo ci = cmcFullReq.getContentInfo();
+                content = ci.getContent();
+
+            } else { // for unsigned revocation requests (using shared secret)
+                CMS.debug(method + "cmc request content is unsigned data");
+                content = (OCTET_STRING) cmcReq.getInterpretedContent();
+            }
             ByteArrayInputStream s = new ByteArrayInputStream(content.toByteArray());
-            PKIData pkiData = (PKIData) (new PKIData.Template()).decode(s);
+            pkiData = (PKIData) (new PKIData.Template()).decode(s);
 
             mCMCData = pkiData;
             //PKIData pkiData = (PKIData)
@@ -707,6 +716,8 @@ public abstract class EnrollProfile extends BasicProfile
             byte randomSeed[] = null;
             UTF8String ident_s = null;
             SessionContext context = SessionContext.getContext();
+
+            boolean id_cmc_revokeRequest = false;
             if (!context.containsKey("numOfControls")) {
                 CMS.debug(method + "numcontrols="+ numcontrols);
                 if (numcontrols > 0) {
@@ -734,7 +745,13 @@ public abstract class EnrollProfile extends BasicProfile
                     for (int i = 0; i < numcontrols; i++) {
                         attributes[i] = (TaggedAttribute) controlSeq.elementAt(i);
                         OBJECT_IDENTIFIER oid = attributes[i].getType();
-                        if (oid.equals(OBJECT_IDENTIFIER.id_cmc_decryptedPOP)) {
+                        if (oid.equals(OBJECT_IDENTIFIER.id_cmc_revokeRequest)) {
+                            id_cmc_revokeRequest = true;
+                            // put in context for processing in 
+                            // CMCOutputTemplate.java later
+                            context.put(OBJECT_IDENTIFIER.id_cmc_revokeRequest,
+                                    attributes[i]);
+                        } else if (oid.equals(OBJECT_IDENTIFIER.id_cmc_decryptedPOP)) {
                             CMS.debug(method + " id_cmc_decryptedPOP found");
                             id_cmc_decryptedPOP = true;
                             decPopVals = attributes[i].getValues();
@@ -765,6 +782,10 @@ public abstract class EnrollProfile extends BasicProfile
                      */
                     CMS.debug(method + "processing controls...");
 
+                    if (id_cmc_revokeRequest) {
+                        CMS.debug(method + "revocation control");
+                    }
+
                     if (id_cmc_identification) {
                         if (ident == null) {
                             msg = "id_cmc_identification contains null attribute value";
@@ -800,7 +821,7 @@ public abstract class EnrollProfile extends BasicProfile
 
                     // checking Proof Of Identity, if not pre-signed
 
-                    if (donePOI) {
+                    if (donePOI || id_cmc_revokeRequest) {
                         // for logging purposes
                         if (id_cmc_identityProofV2) {
                             CMS.debug(method
@@ -920,6 +941,7 @@ public abstract class EnrollProfile extends BasicProfile
             SEQUENCE otherMsgSeq = pkiData.getOtherMsgSequence();
             int numOtherMsgs = otherMsgSeq.size();
             if (!context.containsKey("numOfOtherMsgs")) {
+                CMS.debug(method + "found numOfOtherMsgs: " + numOtherMsgs);
                 context.put("numOfOtherMsgs", Integer.valueOf(numOtherMsgs));
                 for (int i = 0; i < numOtherMsgs; i++) {
                     OtherMsg omsg = (OtherMsg) (ASN1Util.decode(OtherMsg.getTemplate(),
@@ -958,6 +980,8 @@ public abstract class EnrollProfile extends BasicProfile
                 boolean valid = true;
                 for (int i = 0; i < nummsgs; i++) {
                     msgs[i] = (TaggedRequest) reqSeq.elementAt(i);
+                    if (id_cmc_revokeRequest)
+                        continue;
                     if (popLinkWitnessRequired &&
                             !context.containsKey("POPLinkWitnessV2") &&
                             !context.containsKey("POPLinkWitness")) {
@@ -1272,7 +1296,7 @@ public abstract class EnrollProfile extends BasicProfile
         boolean sharedSecretFound = true;
         String configName = "cmc.sharedSecret.class";
         String sharedSecret = null;
-        ISharedToken tokenClass = getSharedTokenClass(configName);
+        ISharedToken tokenClass = CMS.getSharedTokenClass(configName);
         if (tokenClass == null) {
             CMS.debug(method + " Failed to retrieve shared secret plugin class");
             sharedSecretFound = false;
@@ -1499,40 +1523,6 @@ public abstract class EnrollProfile extends BasicProfile
         return bpids;
     }
 
-
-    ISharedToken getSharedTokenClass(String configName) {
-        String method = "EnrollProfile: getSharedTokenClass: ";
-        ISharedToken tokenClass = null;
-
-        String name = null;
-        try {
-            CMS.debug(method + "getting :" + configName);
-            name = CMS.getConfigStore().getString(configName);
-            CMS.debug(method + "Shared Secret plugin class name retrieved:" +
-                    name);
-        } catch (Exception e) {
-            CMS.debug(method + " Failed to retrieve shared secret plugin class name");
-            return null;
-        }
-
-        try {
-            tokenClass = (ISharedToken) Class.forName(name).newInstance();
-            CMS.debug(method + "Shared Secret plugin class retrieved");
-        } catch (ClassNotFoundException e) {
-            CMS.debug(method + " Failed to find class name: " + name);
-            return null;
-        } catch (InstantiationException e) {
-            CMS.debug("EnrollProfile: Failed to instantiate class: " + name);
-            return null;
-        } catch (IllegalAccessException e) {
-            CMS.debug(method + " Illegal access: " + name);
-            return null;
-        }
-
-        return tokenClass;
-    }
-
-
     /**
      * verifyIdentityProofV2 handles IdentityProofV2 as defined by RFC5272
      *
@@ -1578,7 +1568,7 @@ public abstract class EnrollProfile extends BasicProfile
         }
 
         String configName = "cmc.sharedSecret.class";
-        ISharedToken tokenClass = getSharedTokenClass(configName);
+        ISharedToken tokenClass = CMS.getSharedTokenClass(configName);
 
         if (tokenClass == null) {
             msg = " Failed to retrieve shared secret plugin class";
@@ -1682,7 +1672,7 @@ public abstract class EnrollProfile extends BasicProfile
             return false;
 
         String configName = "cmc.sharedSecret.class";
-            ISharedToken tokenClass = getSharedTokenClass(configName);
+            ISharedToken tokenClass = CMS.getSharedTokenClass(configName);
         if (tokenClass == null) {
             CMS.debug(method + " Failed to retrieve shared secret plugin class");
             return false;
diff --git a/base/server/cms/src/com/netscape/cms/servlet/cert/CMCRevReqServlet.java b/base/server/cms/src/com/netscape/cms/servlet/cert/CMCRevReqServlet.java
index 24ba494..a66cd95 100644
--- a/base/server/cms/src/com/netscape/cms/servlet/cert/CMCRevReqServlet.java
+++ b/base/server/cms/src/com/netscape/cms/servlet/cert/CMCRevReqServlet.java
@@ -142,6 +142,8 @@ public class CMCRevReqServlet extends CMSServlet {
      * @param cmsReq the object holding the request and response information
      */
     protected void process(CMSRequest cmsReq) throws EBaseException {
+        String method = "CMCRevReqServlet: process: ";
+        CMS.debug(method + "begins");
 
         String cmcAgentSerialNumber = null;
         IArgBlock httpParams = cmsReq.getHttpParams();
@@ -151,7 +153,7 @@ public class CMCRevReqServlet extends CMSServlet {
         CMSTemplate form = null;
         Locale[] locale = new Locale[1];
 
-        CMS.debug("**** mFormPath = " + mFormPath);
+        CMS.debug(method + "**** mFormPath = " + mFormPath);
         try {
             form = getTemplate(mFormPath, req, locale);
         } catch (IOException e) {
diff --git a/base/server/cms/src/com/netscape/cms/servlet/cert/ListCerts.java b/base/server/cms/src/com/netscape/cms/servlet/cert/ListCerts.java
index 3794f10..01c4b6a 100644
--- a/base/server/cms/src/com/netscape/cms/servlet/cert/ListCerts.java
+++ b/base/server/cms/src/com/netscape/cms/servlet/cert/ListCerts.java
@@ -461,11 +461,11 @@ public class ListCerts extends CMSServlet {
                 ICertRecord rec = e.nextElement();
 
                 if (rec == null) {
-                    CMS.debug("ListCerts: * record " + count + " is null");
+                    //CMS.debug("ListCerts: * record " + count + " is null");
                     break;
                 }
                 curSerial = rec.getSerialNumber();
-                CMS.debug("ListCerts: * record " + count + ": " + curSerial);
+                //CMS.debug("ListCerts: * record " + count + ": " + curSerial);
 
                 if (count == 0) {
                     firstSerial = curSerial;
@@ -493,11 +493,11 @@ public class ListCerts extends CMSServlet {
                 }
 
                 if (mReverse) {
-                    CMS.debug("ListCerts: returning with rcount: " + rcount);
+                    //CMS.debug("ListCerts: returning with rcount: " + rcount);
                     recs[rcount++] = rec;
 
                 } else {
-                    CMS.debug("ListCerts: returning with arg block");
+                    //CMS.debug("ListCerts: returning with arg block");
                     IArgBlock rarg = CMS.createArgBlock();
                     fillRecordIntoArg(rec, rarg);
                     argSet.addRepeatRecord(rarg);
@@ -514,7 +514,7 @@ public class ListCerts extends CMSServlet {
             CMS.debug("ListCerts: fill records into arg block and argSet");
             for (int ii = rcount - 1; ii >= 0; ii--) {
                 if (recs[ii] != null) {
-                    CMS.debug("ListCerts: processing recs[" + ii + "]");
+                    //CMS.debug("ListCerts: processing recs[" + ii + "]");
                     IArgBlock rarg = CMS.createArgBlock();
                     // CMS.debug("item " + ii + " is serial #" + recs[ii].getSerialNumber());
                     fillRecordIntoArg(recs[ii], rarg);
